from ...tl.mtproto_request import MTProtoRequest


class ChannelParticipantModerator(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    channelParticipantModerator#91057fef user_id:int inviter_id:int date:date = ChannelParticipant"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x91057fef
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xd9c7fc18

    def __init__(self, user_id, inviter_id, date):
        """
        :param user_id: Telegram type: "int".
        :param inviter_id: Telegram type: "int".
        :param date: Telegram type: "date".

        Constructor for ChannelParticipant: Instance of either ChannelParticipant, ChannelParticipantSelf, ChannelParticipantModerator, ChannelParticipantEditor, ChannelParticipantKicked, ChannelParticipantCreator.
        """
        super().__init__()

        self.user_id = user_id
        self.inviter_id = inviter_id
        self.date = date

    def to_dict(self):
        return {
            'user_id': self.user_id,
            'inviter_id': self.inviter_id,
            'date': self.date,
        }

    def on_send(self, writer):
        writer.write_int(ChannelParticipantModerator.constructor_id, signed=False)
        writer.write_int(self.user_id)
        writer.write_int(self.inviter_id)
        writer.tgwrite_date(self.date)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return ChannelParticipantModerator(None, None, None)

    def on_response(self, reader):
        self.user_id = reader.read_int()
        self.inviter_id = reader.read_int()
        self.date = reader.tgread_date()

    def __repr__(self):
        return 'channelParticipantModerator#91057fef user_id:int inviter_id:int date:date = ChannelParticipant'

    def __str__(self):
        return '(channelParticipantModerator (ID: 0x91057fef) = (user_id={}, inviter_id={}, date={}))'.format(str(self.user_id), str(self.inviter_id), str(self.date))
